package com.dragonsblaze.client;

import com.dragonsblaze.client.util.LogUtils;
import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.Response;
import com.google.gwt.http.client.URL;
import com.google.gwt.json.client.JSONValue;

public class Rpc
{
	public static void call(String name, JSONValue data, RequestCallback callback)
	{
		String url = "/rpc/" + name;
		String requestData = null;

		RequestBuilder builder;
		if (data == null)
		{
			builder = new RequestBuilder(RequestBuilder.GET, URL.encode(url));
		}
		else
		{
			builder = new RequestBuilder(RequestBuilder.POST, URL.encode(url));
			requestData = data.toString();
		}

		try
		{
			builder.sendRequest(requestData, callback);
		}
		catch (RequestException e)
		{
			callback.onError(null, e);
		}
	}

	public static class Callback implements RequestCallback
	{
		@Override
		public void onResponseReceived(Request request, Response response)
		{
		}

		@Override
		public void onError(Request request, Throwable exception)
		{
			LogUtils.error("RPC Error: " + exception.getMessage());
		}
	}
}
