package com.dragonsblaze.client.command;

import com.dragonsblaze.client.Controller;
import com.google.gwt.user.client.Command;

/**
 * Restores the specified view and view state, and adds it to browser session history
 */
public class ControllerCommand implements Command
{
	private final String token, state;

	public ControllerCommand(String token)
	{
		this.token = token;
		this.state = "";
	}

	public ControllerCommand(String token, String state)
	{
		this.token = token;
		this.state = state;
	}

	@Override
	public void execute()
	{
		Controller.getInstance().restoreState(token, state, true);
	}
}
