package com.dragonsblaze.client.util;

import java.util.ArrayList;

import com.google.gwt.user.client.Command;

public class History
{
	public static final boolean supported = isHistorySupported();

	private static boolean initialized = false;

	private static ArrayList<Command> handlers;

	private static final native boolean isHistorySupported() /*-{
		return !!($wnd.history && $wnd.history.pushState);
	}-*/;
	
	/**
	 * Pushes given path to the session history
	 */
	public final static native void pushPath(String path) /*-{
		$wnd.history.pushState(null, null, path);
	}-*/;

	/**
	 * Subscribes to browser's "popstate" history event
	 */
	public static void subscribe(Command handler)
	{
		if(!supported)
			return;
		
		if (!initialized)
		{
			handlers = new ArrayList<Command>();
			subscribeToPopState();
			initialized = true;
		}

		handlers.add(handler);
	}

	private static void popStateHandler()
	{
		if (handlers == null)
			return;

		for (Command handler : handlers)
			handler.execute();
	}

	private static native void subscribeToPopState() /*-{
		$wnd.$($wnd).bind('popstate', function(event) {
			@com.dragonsblaze.client.util.History::popStateHandler()();
		});
	}-*/;
}
