package com.dragonsblaze.client.util;

import com.google.gwt.storage.client.Storage;

public class LocalStorage
{
	public static final boolean supported = Storage.isLocalStorageSupported();

	public static String get(Enum<?> key)
	{
		return get(key, "");
	}

	public static String get(Enum<?> key, String defaultValue)
	{
		if (!supported)
			return defaultValue;
		String data = Storage.getLocalStorageIfSupported().getItem(key.name());
		if(data == null)
			return defaultValue;
		return data;
	}

	public static void put(Enum<?> key, String data)
	{
		if (!supported)
			return;
		Storage.getLocalStorageIfSupported().setItem(key.name(), data);
	}

	public static void delete(Enum<?> key)
	{
		if (!supported)
			return;
		Storage.getLocalStorageIfSupported().removeItem(key.name());
	}
}
